#include <nostub.h>
#include <all.h>

int _ti89,_ti92plus;			// produce .89z files 

int g[5][7] = {{0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0}};

int m[5][7] = {{1,2,2,2,2,2,1},
	       {2,3,3,3,3,3,2},
	       {2,3,3,3,3,3,2},
	       {2,3,3,3,3,3,2},
	       {1,2,2,2,2,2,1}};

int abs(int x)
{
return x<0?-1*x:x;
}


int show_grid()
{
int x;
int y;
SCR_RECT a_rect = {0,0,0,0};
int p1count = 0;
int p2count = 0;
char a_string[40];

//ClrScr();
ScrRectFill (ScrRect, ScrRect, A_REVERSE);
for(x = 0; x < 7; x++)
{
for(y = 0; y < 5; y++)
{
printf_xy(20*x+15, 13*y+8, "%d",g[y][x]<0?-1*g[y][x]:g[y][x]);
if(g[y][x]<0)
{
a_rect.xy.x0 = 20*x+12;
a_rect.xy.y0 = 13*y+6;
a_rect.xy.x1 = 20*x+24;
a_rect.xy.y1 = 13*y+17;
ScrRectFill ( &a_rect, ScrRect, A_XOR);
p2count -= g[y][x];
} else {
p1count += g[y][x];
}
}
}
sprintf(&a_string, "Atoms: Player 1 = %d, Player 2 = %d", p1count, p2count);
ST_helpMsg(&a_string);
if((p1count == p2count) | (p1count + p2count < 3))
	return 0;
if(p1count == 0)
	return 2;
if(p2count == 0)
	return 1;
}

int place(int x, int y, int p)
{
g[y][x] = p*(abs(g[y][x])+1);
show_grid();

if(p*g[y][x] <= m[y][x])
return;

g[y][x] = 0;
show_grid();

if(x==0)
{
place(x+1,y,p);
} else {
if(x==6)
{
place(x-1,y,p);
} else {
place(x-1,y,p);
place(x+1,y,p);
}
}

if(y==0)
{
place(x,y+1,p);
} else {
if(x==4)
{
place(x,y-1,p);
} else {
place(x,y-1,p);
place(x,y+1,p);
}
}

}



int _main ()			// main entry point is function _main
{
unsigned int result;
LCD_BUFFER buffer;
int p = 1;
int i;
int k;
int x;
int y;
int sg = 0;
char a_string[40];
SCR_RECT a_rect = {2,75,85,99};

LCD_save (buffer);

for(x = 0; x < 7; x++)
{
for(y = 0; y < 5; y++)
{
g[y][x] = 0;
}
}
// Draw title screen
ClrScr ();
FontSetSys(F_8x10);
DrawStr(15,2,"Atoms v0.1",A_NORMAL);
FontSetSys(F_6x8);
DrawStr(3,15,"by Christopher Waudby",A_NORMAL);
DrawStr(3,26," quadby@geocities.com",A_NORMAL);
DrawLine(2,38,157,38,A_NORMAL);
FontSetSys(F_4x6);
DrawStr(3,41,"Take turns to add atoms to a 7x5 grid.",A_NORMAL);
DrawStr(3,48,"Corners can hold 1 atoms, edges 2 atoms,",A_NORMAL);
DrawStr(3,55,"and other squares 3 atoms. Add any more and",A_NORMAL);
DrawStr(3,62,"the atoms explode into neighboring squares.",A_NORMAL);
DrawStr(3,69,"Your opponents atoms are captured if",A_NORMAL);
DrawStr(3,76,"involved in an explosion. The aim of the",A_NORMAL);
DrawStr(3,83,"game is to remove all your opponent's",A_NORMAL);
DrawStr(3,90,"atoms from the grid. Have fun!",A_NORMAL);

FontSetSys(F_6x8);
GKeyFlush();
ngetchx ();
ClrScr();

show_grid();
for(;;)
{
FontSetSys(F_4x6);
sprintf(&a_string, "Player %d",(((1-p)/2)+1));
DrawStr(3,76,&a_string,A_NORMAL);
DrawStr(10,84,"Column:",A_NORMAL);
for(;;)
{
GKeyFlush();
k = ngetchx();
if(k == 264)
	break;
k = k - 48;
if((k > 0) & (k < 8))
	break;
}
if(k == 264)
	break;
x = k;
sprintf(&a_string, "%d",x);
DrawStr(40,84,&a_string,A_NORMAL);
DrawStr(60,84,"Row:",A_NORMAL);
for(;;)
{
GKeyFlush();
k = ngetchx();
if(k == 264)
	break;
k = k - 48;
if((k > 0) & (k <6))
	break;
}
if(k == 264)
	break;
y = k;
sprintf(&a_string, "%d",y);
DrawStr(78,84,&a_string,A_NORMAL);
FontSetSys(F_6x8);
if((abs(g[y-1][x-1]) != p*g[y-1][x-1]) & (g[y-1][x-1] != 0))
{
ST_helpMsg("You cannot select an opponents grid");
ScrRectFill ( &a_rect, ScrRect, A_REVERSE);
continue;
}
place(x-1,y-1,p);
sg = show_grid();
if(sg != 0)
	break;
p *= -1;
}

if(sg == 1)
{
FontSetSys(F_8x10);
DrawStr(3,76,"Player 1 wins!",A_NORMAL);
GKeyFlush();
ngetchx();
}

if(sg == 2)
{
FontSetSys(F_8x10);
DrawStr(3,76,"Player 2 wins!",A_NORMAL);
GKeyFlush();
ngetchx();
}

LCD_restore (buffer);
return 0;
}

